"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Call(ProtocolElement):
    """
    A `Call` represents the determination of genotype with respect to a
    particular `Variant`.  It may include associated information such
    as quality and phasing. For example, a call might assign a
    probability of 0.32 to the occurrence of a SNP named rs1234 in a
    call set with the name NA12345.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import ga4gh as ga4gh_3_0_0

        return {
            "org.ga4gh.models.Call": ga4gh_3_0_0.Call,
        }

    __slots__ = [
        "callSetId",
        "callSetName",
        "genotype",
        "genotypeLikelihood",
        "info",
        "phaseset",
    ]

    def __init__(
        self,
        callSetId=None,
        callSetName=None,
        genotype=list,
        genotypeLikelihood=list,
        info=dict,
        phaseset=None,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_0_0.Call model.

        :param callSetId:
            The ID of the call set this variant call belongs to.    If this field
            is not present, the ordering of the call sets from a
            `SearchCallSetsRequest` over this `VariantSet` is
            guaranteed to match   the ordering of the calls on this
            `Variant`.   The number of results will also be the same.
        :type callSetId: None | str
        :param callSetName:
            The name of the call set this variant call belongs to.   If this field
            is not present, the ordering of the call sets from a
            `SearchCallSetsRequest` over this `VariantSet` is
            guaranteed to match   the ordering of the calls on this
            `Variant`.   The number of results will also be the same.
        :type callSetName: None | str
        :param genotype:
            The genotype of this variant call.    A 0 value represents the
            reference allele of the associated `Variant`. Any   other
            value is a 1-based index into the alternate alleles of the
            associated   `Variant`.    If a variant had a
            referenceBases field of "T", an alternateBases   value of
            ["A", "C"], and the genotype was [2, 1], that would mean
            the call   represented the heterozygous value "CA" for
            this variant. If the genotype   was instead [0, 1] the
            represented value would be "TA". Ordering of the
            genotype values is important if the phaseset field is
            present.
        :type genotype: list[int]
        :param genotypeLikelihood:
            The genotype likelihoods for this variant call. Each array entry
            represents how likely a specific genotype is for this call
            as   log10(P(data | genotype)), analogous to the GL tag in
            the VCF spec. The   value ordering is defined by the GL
            tag in the VCF spec.
        :type genotypeLikelihood: list[double]
        :param info:
            A map of additional variant call information.
        :type info: dict[str, list[str]]
        :param phaseset:
            If this field is not null, this variant call's genotype ordering
            implies   the phase of the bases and is consistent with
            any other variant calls on   the same contig which have
            the same phaseset string.
        :type phaseset: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.0.0"
